package br.com.jbpm.manager;

import org.apache.log4j.Logger;
import org.drools.runtime.StatefulKnowledgeSession;
import org.springframework.stereotype.Component;

import br.com.impl.knowledge.EasyPieKnowledgeSessionImpl;

@Component
public class SessionManager {

	private static final Logger	LOGGER = Logger.getLogger(SessionManager.class);
	
	private final EasyPieKnowledgeSessionImpl kSession = new EasyPieKnowledgeSessionImpl();
	
	/**
	 * Uma instância <b>persistente</b> é criada.
	 * @return O id da sessão criada.
	 */
	public Integer createNewPersistentSession() {
		LOGGER.info("CREATE NEW PERSISTENT SESSION");
		
		StatefulKnowledgeSession session = kSession.newStatefulKnowledgeSession(ProcessManager.getKnowledgeBase(), new ProcessManager().getEnvironment());

		Integer sessionId = session.getId();

		return sessionId;
	}

	public StatefulKnowledgeSession getSession() {

		return kSession.getKsession();
	}

	public EasyPieKnowledgeSessionImpl getKnowledgeSession() {
		return kSession;
	}
	
}
